Package tigase.xmpp.impl

# Class AbstractAuthPreprocessor

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.xmpp.impl.AbstractAuthPreprocessor

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `XMPPImplIfc`, `XMPPPreprocessorIfc`, `XMPPProcessorConcurrencyAwareIfc`

Direct Known Subclasses:
  `JabberIqAuth`, `SaslAuthAbstract`

public abstract class AbstractAuthPreprocessor extends XMPPProcessor implements XMPPPreprocessorIfc
Abstract class which should be extended by any authorization processor as it implements preprocessor feature which is responsible for stopping not allowed packets from not yet authorized client connections.

Author:
  andrzej

- ## Field Summary

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractAuthPreprocessor()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addInvalidLogin(XMPPResourceConnection session, String ip, BareJID jid)`
  `protected void`
  `disableUser(XMPPResourceConnection session, BareJID userJID)`
  `protected BareJID`
  `extractUserJid(Exception e, XMPPResourceConnection session)`
  `String[]`
  `getAllowMatchers()`
  `protected boolean`
  `isBruteForceLockerEnabled(XMPPResourceConnection session)`
  `protected boolean`
  `isLoginAllowedByBruteForceLocker(XMPPResourceConnection session, String clientIp, BareJID jid)`
  `protected boolean`
  `isPacketAllowed(Packet packet)`
  `boolean`
  `preProcess(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  Performs pre-processing of `packet`.
  `protected void`
  `saveIntoBruteForceLocker(XMPPResourceConnection session, Exception e)`
  `void`
  `setAllowMatchers(String[] matcherStrs)`
  `void`
  `setBruteForceLocker(BruteForceLockerBean bruteForceLocker)`

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, id, init, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

- ## Constructor Details

  - ### AbstractAuthPreprocessor

    public AbstractAuthPreprocessor()

- ## Method Details

  - ### isBruteForceLockerEnabled

    protected boolean isBruteForceLockerEnabled(XMPPResourceConnection session)

  - ### addInvalidLogin

    public void addInvalidLogin(XMPPResourceConnection session, String ip, BareJID jid)

  - ### isLoginAllowedByBruteForceLocker

    protected boolean isLoginAllowedByBruteForceLocker(XMPPResourceConnection session, String clientIp, BareJID jid)

  - ### preProcess

    public boolean preProcess(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)
    Description copied from interface: `XMPPPreprocessorIfc`
    Performs pre-processing of `packet`. Intention for the pre-processors is to allow them for packet blocking.
    Specified by:
      `preProcess` in interface `XMPPPreprocessorIfc`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Returns:
      the pre-processing result; if the value is ‘true’ then the packet is blocked and no further processing is performed.

  - ### getAllowMatchers

    public String[] getAllowMatchers()

  - ### saveIntoBruteForceLocker

    protected void saveIntoBruteForceLocker(XMPPResourceConnection session, Exception e)

  - ### setAllowMatchers

    public void setAllowMatchers(String[] matcherStrs)

  - ### isPacketAllowed

    protected boolean isPacketAllowed(Packet packet)

  - ### setBruteForceLocker

    public void setBruteForceLocker(BruteForceLockerBean bruteForceLocker)

  - ### disableUser

    protected void disableUser(XMPPResourceConnection session, BareJID userJID)

  - ### extractUserJid

    protected BareJID extractUserJid(Exception e, XMPPResourceConnection session)